.TH "inundator" "1" "29 June 2010" "inundator-0.5" "because you're worth it."
.nh
.ad b

.SH NAME
inundator \- fills IDS/IPS/WAF logs with false positives to obfuscate an attack.
.SH SYNOPSIS

\fBinundator\fR [\fB-nu\fR] [\fB-a \fIuser:pass\fB\fR] [\fB-d \fIdelay\fB\fR] [\fB-p \fIserver:port\fB\fR] [\fB-r \fI/path/to/rules\fB\fR] [\fB-s \fIsocks version\fB\fR] [\fB-t \fIthreads\fB\fR] \fB\fItarget(s)\fB\fR

.SH "DESCRIPTION"
.PP
\fBinundator\fR is a tool used to anonymously inundate intrusion detection logs with false positives to obfuscate a real attack, leaving the IDS analyst feeling completely inundated.

The general idea is one would launch \fBinundator\fR prior to starting an attack, allow it to run during the attack, and continue to run it a while longer after you've accomplished the attack. The goal, of course, is to generate an overwhelming number of false positives so that your real attack is essentially buried within the other alerts, minimizing the chance of your attack being detected.

At a high level, \fBinundator\fR achieves this by parsing enough data from Snort's rules files to generate packets or requests that match each rule. Because Snort rules are typically poorly written and of low quality, we cannot glean enough data from the rules files to construct a real attack; instead, we generate a completely innocent packet or request that contains just enough keywords to trigger a false positive. Since we parse rules in a generic way, not all generated attacks will actually trigger an alert. The measured success rate is around 90%, which we deem acceptable. Of course, the IDS configuration on the target will play a very large part in whether our false attacks are detected or not as well.

\fBinundator\fR is multithreaded, queue-driven, and supports multiple targets in a variety of standard formats. As the Snort rules are parsed, attacks are queued up and organized by dport. Open ports on each target are then detected by performing an nmap scan, and each target as well as a list of its open ports are queued up. A random target is then selected from the queue by each worker thread, along with a random open port on that target. A random attack is then selected for the selected port, and the attack is sent via a SOCKS proxy. \fBinundator\fR attempts to use Tor's SOCKS proxy by default, but you may specify any SOCKS proxy, including those requiring authentication.

.SH "OPTIONS"
\fBinundator\fP follows the usual GNU command line syntax, with long options starting with two dashes (`-').
A summary of options is included below.
.TP
\fB-a, \-\-auth\fR
Authentication credentials for SOCKS proxy in \fIuser:pass\fR format. This is undefined by default, and will typically only be used with \fB--proxy\fR.
.TP
\fB-d, \-\-delay\fR
Delay in \fImicroseconds\fR (millionths of a second) after sending an attack. This value is applied per thread, not globally. Because we use Tor by default and Tor is a bit slow, the default delay is set to 0mus. When using a much faster SOCKS proxy, you may want to set the delay a tad higher and set the number of threads a tad lower to prevent a local denial of service.
.TP
\fB-n, \-\-no-threads\fR
Disable thread support. Perl's ithread library will not be loaded, and the script will continue to attack with only a singular loop. Threads are enabled by default and their use is recommended.
.TP
\fB-p, \-\-proxy\fR
Define the SOCKS proxy we use to send attacks in \fIhost:port\fR format. The use of a SOCKS proxy is mandatory for rather obvious reasons, and the use of Tor is strongly recommended. We use localhost:9050 by default.
.TP
\fB-r, \-\-rules\fR
Location of our Snort rules files. This can be an absolute or relative path to the parent directory. The default location is \fI/etc/snort/rules/\fR.
.TP
\fB-s, \-\-socks-version\fR
Specify which SOCKS version to use (\fI4|5\fR). We default to version 5.
.TP
\fB-t, \-\-threads\fR
Number of concurrent threads to spawn. Be careful setting this too high! We default to \fI25\fR threads.
.TP
\fB-u, \-\-use-comments\fR
By default, we ignore commented lines in the Snort rules files. This maximizes the chance our attacks will be detected by the target's intrusion detection mechanisms. However, if you wish to use all rules, including those that are commented out, this switch will enable you to do so. 
.TP
\fB\-\-verbose\fR
Enable verbose output, becoming extremely chatty. If you're afraid inundator isn't working, enable this switch. Some connection errors are normal; a lot of connection errors means something is wrong. This switch will show you how many connections are succeeding and how many are failing.
.TP
\fB\-\-Version\fR
Print version information and exit. Please include the output of this command when filing a bug report.

.SH "TARGETS"
.TP
\fBSingle Host\fR
You may target a single host, either by \fIip address\fR or by \fIfully-qualified domain name\fR.
.TP
\fBIP Range\fR
You may target a range of ip addresses, e.g. \fI192.168.0.10-192.168.0.25\fR.
.TP
\fBSubnet\fR
You may target an entire subnet in CIDR format, e.g. \fI192.168.0.0/16\fR.

.SH "BUGS"
None ;) But if you DO happen to discover a bug, please file a bug report at \fIhttps://sf.net/tracker/?group_id=332158\fR. Please include the output of --Version with your bug report. This URL may also be used to submit feature requests and patches.

.SH "SEE ALSO"
.PP
\fBsnort\fR(8),
\fBoinkmaster\fR(1).
.SH "HISTORY"
We thought this was an original idea. Not the idea of filling logs, but rather the idea of parsing Snort rules files to generate false positives. But apparently tools like \fISnot\fR, \fIfwsnort's snortspoof\fR, and others do similar things. However, most of these tools are quite dated and inferior, so consider \fBinundator\fR a new and improved twist on an old idea.

.SH "SECURITY"
\fIYou have none.\fR

.SH "AVAILABILITY"
\fBinundator\fR is available in both source tarball and package form from \fIhttp://inundator.bindshell.nl/\fR.

.SH AUTHORS
inundator was written by \fBepixoip\fR \fI<epixoip@bindshell.nl>\fR and \fBL10n\fR \fI<lion@bindshell.nl>\fR.
